/*!
**********************************************************
* HeroMagic.js
* https://github.com/mike-zarandona/HeroMagic.js
*
* Version:       1.0.2
* Author:        Mike Zarandona | @mikezarandona
* Release:       Jul 07 2017
*                Complex transition positioning fix
**********************************************************
*/
!function(t,a,s,o){t.fn.heroMagic=function(a){"use strict";var e=(t(this),0);return a=t.extend({},t.fn.heroMagic.options,a),this.initialize=function(){if(a.scrollOutDistance+a.scrollInDistance>=t(s).outerHeight()&&console.warn("HeroMagic.js: The options for `scrollOutDistance` and `scrollInDistance` are the same or a greater total height than the current viewport."),a.addStyles&&0===t("#heromagic-styles").length){var i="";i+="[data-appear],.hm-fade-in,.hm-fade-out{opacity:0;will-change:opacity;}",i+="[data-move],.hm-scroll-in,.hm-scroll-out{will-change:transform;}",i+="[data-appear][data-move],.hm-fade-in.hm-scroll-out,.hm-fade-out.hm-scroll-in{will-change:opacity,transform;}",t("head").append('<style id="heromagic-styles" type="text/css">'+i+"</style>")}if(a.debugScrollPoints){var n="";n+="body{position:relative;}",n+='body::before{content:"";display:block;position:fixed;z-index:99999;top:'+a.scrollOutDistance+"px;left:0;width:100%;border-bottom:1px dashed red;}",n+='body::after{content:"";display:block;position:fixed;z-index:99999;bottom:'+a.scrollInDistance+"px;left:0;width:100%;border-top:1px dashed red;}",t("head").append('<style id="heromagic-styles-debug" type="text/css">'+n+"</style>")}return t("[data-appear], [data-move]").each(function(){var s=t(this),i="";if(s.data("appear")!==o){i="";var n=s.attr("data-appear").split(","),r=n[0].trim()||a.defaults.appearDuration,l=n[1].trim()||a.defaults.appearEasing,c=n[2].trim()||a.defaults.appearDelay;s.data("thisAppearDuration",r).data("thisAppearEasing",l).data("thisAppearDelay",c),s.css("transition")!==o&&(i+=s.css("transition")+", "),i+="opacity "+r+" "+l+" "+c,s.css("transition",i)}if(s.data("move")!==o){i="";var p=s.attr("data-move").split(","),d=p[0].trim()||a.defaults.moveX,h=p[1].trim()||a.defaults.moveY,m=p[2].trim()||a.defaults.moveDuration,u=p[3].trim()||a.defaults.moveEasing,f=p[4].trim()||a.defaults.moveDelay;s.data("thisMoveX",d).data("thisMoveY",h).data("thisMoveDuration",m).data("thisMoveEasing",u).data("thisMoveDelay",f),"relative"!==s.css("position")&&"absolute"!==s.css("position")&&"fixed"!==s.css("position")&&s.css("position","relative"),0!==h&&s.css("bottom",h),0!==d&&s.css("right",d),s.css("transition")!==o&&(i+=s.css("transition")+", "),i+="transform "+m+" "+u+" "+f,s.css("transition",i)}s.data("transitioning")!==o&&0!==s.data("transitioning")&&e++}),a.autoStart&&this.animate(),this},this.animate=function(){return t("[data-appear], [data-move]").each(function(){var a=t(this);a.data("appear")!==o&&setTimeout(function(){a.css("opacity","1"),a.one("transitionend.appear",function(t){a.css("transition","none")})},a.data("thisAppearDelay")),a.data("move")!==o&&setTimeout(function(){a.css("transform","translate3d("+a.data("thisMoveX")+", "+a.data("thisMoveY")+", 0"),a.one("transitionend.move",function(t){a.css("transition","none");var s=a.css("top"),o=a.css("bottom");"auto"!==s&&"auto"!==o||"auto"===s&&"auto"===o?a.css("top",parseInt(s)+parseInt(a.data("thisMoveY"))+"px"):"auto"!==s&&"auto"===o?a.css("top",parseInt(a.css("top"))+parseInt(a.data("thisMoveY"))+"px"):"auto"!==o&&"auto"===s&&a.css("bottom",parseInt(a.css("bottom"))+parseInt(a.data("thisMoveY"))+"px"),a.css("transform","translate3d("+a.data("thisMoveX")+", 0, 0)")})},a.data("thisMoveDelay"))}),this.scrolls(),this},this.scrolls=function(){var o=t(".hm-scroll-out, .hm-scroll-in, .hm-fade-out, .hm-fade-in");return 0!==o.length&&t(s).on("scroll",function(){var e=t(s).scrollTop();o.each(function(){var o,i,n=t(this),r=n.offset().top-e,l=t(s).outerHeight()-r,c=0,p=0;n.hasClass("hm-fade-out")&&r<=a.scrollOutDistance?(c=r/a.scrollOutDistance,n.css("opacity",c)):n.hasClass("hm-fade-out")&&r>a.scrollOutDistance&&l>a.scrollInDistance&&n.css("opacity",1),n.hasClass("hm-fade-in")&&l>=0&&l<=a.scrollInDistance?(p=l/a.scrollInDistance,n.css("opacity",p)):n.hasClass("hm-fade-in")&&l>a.scrollInDistance&&r>a.scrollOutDistance&&n.css("opacity",1),n.hasClass("hm-scroll-out")&&r<=2*a.scrollOutDistance&&("none"!==n.css("transform")?(i=n.css("transform").split(","),o=i[4],i[5].split(")")[0]):(o=0,0),(c=r/a.scrollOutDistance)>-1&&c<=2&&(c<1?n.css("transform","translate3d("+o+"px, "+-1*(a.scrollOutDistance-r)*a.scrollCompressor+"px, 0)"):n.css("transform","translate3d("+o+"px, 0, 0)"))),n.hasClass("hm-scroll-in")&&l<=2*a.scrollInDistance&&("none"!==n.css("transform")?(i=n.css("transform").split(","),o=i[4],i[5].split(")")[0]):(o=0,0),(p=l/a.scrollInDistance)>-1&&p<=2&&(p<1?n.css("transform","translate3d("+o+"px, "+(a.scrollInDistance-l)*a.scrollCompressor+"px, 0)"):n.css("transform","translate3d("+o+"px, 0, 0)")))})}),this},0===t("[data-appear], [data-move], .hm-fade-in, .hm-fade-out, .hm-scroll-in, .hm-scroll-out").length?(console.warn("HeroMagic.js: No magic parameters nor classes found."),!1):this.initialize()},t.fn.heroMagic.options={addStyles:!0,defaults:{appearDuration:"300ms",appearEasing:"ease-in-out",appearDelay:0,moveX:0,moveY:"-20px",moveDuration:"300ms",moveEasing:"ease-in-out",moveDelay:0},autoStart:!0,positionOverrides:!0,scrollOutDistance:80,scrollInDistance:80,scrollCompressor:.2,debugScrollPoints:!1}}(jQuery,document,window,void 0);